// Copyright (c) 2015, Alexandre Ardhuin
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

part of google_maps.src.geometry;

final encoding = new Encoding.created(
    context['google']['maps']['geometry']['encoding'] as JsObject);

abstract class _Encoding implements JsInterface {
  List<LatLng> decodePath(String encodedPath);
  String encodePath(dynamic /*List<LatLng>|MVCArray<LatLng>*/ path) =>
      _encodePath((new ChainedCodec()
            ..add(new JsListCodec<LatLng>(new JsInterfaceCodec<LatLng>(
                (o) => new LatLng.created(o),
                (o) =>
                    o != null &&
                    o.instanceof(
                        context['google']['maps']['LatLng'] as JsFunction))))
            ..add(new JsInterfaceCodec<MVCArray<LatLng>>((o) =>
                new MVCArray<LatLng>.created(
                    o,
                    new JsInterfaceCodec<LatLng>(
                        (o) => new LatLng.created(o),
                        (o) =>
                            o != null &&
                            o.instanceof(
                                context['google']['maps']['LatLng'] as JsFunction))))))
          .encode(path)) as String;
  _encodePath(dynamic /*List<LatLng>|MVCArray<LatLng>*/ path);
}
